Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus > Class Template Reference
Other available functionality » Integer propagators

Domain consistent n-th root propagator. More...

`#include <arithmetic.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
Public Member Functions inherited from Gecode::BinaryPropagator< IntView, PC_INT_DOM >
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, IntView x0, IntView x1, Ops ops)
| Post propagator.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| NrootPlusDom (Space &home, NrootPlusDom< Ops, minus > &p)
| Constructor for cloning p.
| NrootPlusDom (Home home, IntView x0, IntView x1, const Ops &ops)
| Constructor for posting.
Protected Member Functions inherited from Gecode::BinaryPropagator< IntView, PC_INT_DOM >
| BinaryPropagator (Space &home, BinaryPropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

Ops | ops
| Operations.
Protected Attributes inherited from Gecode::BinaryPropagator< IntView, PC_INT_DOM >
IntView | x0
| Two views.
IntView | x1

## Detailed Description

template<class Ops, bool minus>
class Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >

Domain consistent n-th root propagator.

Requires

#include <gecode/int/arithmetic.hh>
arithmetic.hh

Definition at line 546 of file arithmetic.hh.

## Constructor & Destructor Documentation

## NrootPlusDom() [1/2]

template<class Ops, bool minus>

Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::NrootPlusDom | ( | Space & | home,
|  | NrootPlusDom< Ops, minus > & | p )

inline protected

Constructor for cloning p.

Definition at line 311 of file nroot.hpp.

## NrootPlusDom() [2/2]

template<class Ops, bool minus>

Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::NrootPlusDom | ( | Home | home,
|  | IntView | x0,
|  | IntView | x1,
|  | const Ops & | ops )

inline protected

Constructor for posting.

Definition at line 289 of file nroot.hpp.

## Member Function Documentation

## copy()

template<class Ops, bool minus>

Actor * Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 318 of file nroot.hpp.

## propagate()

template<class Ops, bool minus>

ExecStatus Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 335 of file nroot.hpp.

## cost()

template<class Ops, bool minus>

PropCost Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

If a view has been assigned, the cost is low unary. If in stage for bounds propagation, the cost is low binary. Otherwise it is high binary.

Reimplemented from Gecode::BinaryPropagator< IntView, PC_INT_DOM >.

Definition at line 324 of file nroot.hpp.

## post()

template<class Ops, bool minus>

ExecStatus Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::post | ( | Home | home,
|  | IntView | x0,
|  | IntView | x1,
|  | Ops | ops )

inline static

Post propagator.

Definition at line 296 of file nroot.hpp.

## Member Data Documentation

## ops

template<class Ops, bool minus>

Ops Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >::ops

protected

Operations.

Definition at line 551 of file arithmetic.hh.

The documentation for this class was generated from the following files:

- gecode/int/arithmetic.hh
- gecode/int/arithmetic/nroot.hpp